//+------------------------------------------------------------------+
//|                                                NonLagMA_v1.1.mq4 |
//|                                      Copyright  2007, Rid       |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Rid"
#property link        "--------------"

extern int     MagicNum           =11184;
extern string   _____= "  "; 
extern int     NLg_buy        =  45;
extern double  DV_buy         = -0.1;
extern int     SL_long        =  40;
extern int     TP_long        =  40;
extern int     lMinProfit     = 54;
extern int     lTrailingStop   = 42;
extern int     lTrailingStep  = 10;
extern string   ____= "  ";
extern int     NLg_sell       =  45;
extern double  DV_sell        =  0.1;
extern int     SL_short       = 40;
extern int     TP_short       =  40;
extern int    sMinProfit      = 20;
extern int    sTrailingStop   = 53;
extern int    sTrailingStep   = 4;
extern string   _= "   ";
extern int     NLg_Signal     =  9;
extern int     Slippage       =3;
extern double  Lots           =0.1;
extern bool   UseTrailing = true;
extern bool   AutoClose =true;//
extern int    Stochastic_period  = 13; 


int ticket;
static int prevtime = 0;
//--   --
#include <stdlib.mqh>
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {

 if(Time[0] == prevtime) 
       return(0);
 prevtime = Time[0];
  if (UseTrailing) TrailPositions();   
//----
   double NLg_Signal_0 =iCustom(NULL,0,"NonLagMA_v5",0,NLg_Signal,1,0,0,0,0,0,0); 
   double NLg_Signal_1 =iCustom(NULL,0,"NonLagMA_v5",0,NLg_Signal,1,0,0,0,0,0,1); 
   double NLg_long0    =iCustom(NULL,0,"NonLagMA_v5",0,NLg_buy,0,0,0,0,DV_buy,0,0);
   double NLg_short0   =iCustom(NULL,0,"NonLagMA_v5",0,NLg_sell,0,0,0,0,DV_sell,0,0);

  if (OrdersTotal()   == 0)//   
      { 
//---------   -----------------      
   if   ( 
          (NLg_Signal_1<=NLg_long0)  &&
          (NLg_Signal_0>NLg_long0)  )
   { 
  ticket=OrderSend(Symbol(),0,Lots,Ask,Slippage,Bid-SL_long*Point,Ask+TP_long*Point,
                                                          NULL,MagicNum,0,CLR_NONE);
 if(ticket < 0)  { Sleep(30000); prevtime = Time[1]; }
   else  { Print("    BUY #", GetLastError() ); }        
   }
//---------   ----------------- 
     if  (   
          (NLg_Signal_1>=NLg_short0)  &&
          (NLg_Signal_0<NLg_short0)  )
   { 
  ticket=OrderSend(Symbol(),1,Lots,Bid,Slippage,Bid+SL_short*Point,Bid-TP_short*Point,
                                                             NULL,MagicNum,0,CLR_NONE);
  if(ticket < 0)  { Sleep(30000); prevtime = Time[1]; }
     else  { Print("    BUY #", GetLastError() ); }             
   }
//------------------------------------------------------------------
//*********   ****************************************
if (AutoClose) {  
//----    ----
double Stochast_0 =iStochastic(NULL,0,Stochastic_period,3,3,MODE_SMA,0,MODE_MAIN,0);
double Stochast_1 =iStochastic(NULL,0,Stochastic_period,3,3,MODE_SMA,0,MODE_MAIN,1);
//----------------------------------------------------------------------
  for (int v=0; v<OrdersTotal(); v++)                             {       
      if (OrderSelect(v, SELECT_BY_POS, MODE_TRADES))               {           
        if (OrderSymbol()==Symbol()&& OrderMagicNumber()==MagicNum)   { 
//-----------------------------------------------------                  
if (OrderType() == OP_BUY) { 
      if(Stochast_1>75 && Stochast_0<75)     {
           OrderClose(OrderTicket(),OrderLots(),Bid,3,Green); //  
                 return(0); // 
                }       
     }  
 //--------------------------------------------------------
if (OrderType() == OP_SELL) { 
      if(Stochast_1<25 && Stochast_0>25)    {
                 OrderClose(OrderTicket(),OrderLots(),Ask,3,Green); //  
                 return(0); // 
                }       
     }  
 //-------------------------------------------------------                       
    }  // Symbol()  
  } // select
 } //total
} //Close_ 
 //****************************************************************************   

 } 
   return(0);
      }
//*****************************************************************
void TrailPositions() 
{
 int Orders = OrdersTotal();
  for (int i=0; i<Orders; i++) {
    if (!(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))) continue;
    if (OrderSymbol() != Symbol()) continue;  
    if (OrderType() == OP_BUY) {
      if (Bid-OrderOpenPrice() > lMinProfit*Point) {
        if (OrderStopLoss() < Bid-(lTrailingStop+lTrailingStep-1)*Point) {
          OrderModify(OrderTicket(), OrderOpenPrice(), Bid-lTrailingStop*Point,
                                                    OrderTakeProfit(), 0, Blue);
      }}}
    if (OrderType() == OP_SELL) {
      if (OrderOpenPrice()-Ask > sMinProfit*Point) {
        if (OrderStopLoss() > Ask+(sTrailingStop+sTrailingStep-1)*Point ||
                                                         OrderStopLoss() == 0) {
          OrderModify(OrderTicket(), OrderOpenPrice(), Ask+sTrailingStop*Point,
                                                      OrderTakeProfit(), 0, Blue);
        }}}}}
//----------------------------------------------------------------------- 